<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
				xmlns:math="http://www.w3.org/1998/Math/MathML"
				version="1.0">
<xsl:output method="xml" indent="yes" omit-xml-declaration="yes" encoding="UTF-8"/>
	
<xsl:template match="/*">
<math:math>
<xsl:apply-templates select="@*"/>
			
<xsl:apply-templates select="node()"/>
			
</math:math>
</xsl:template>
	
	
<xsl:template match="math:mo | math:mi | math:mn | math:mtext">
<xsl:variable name="vNodeName">
<xsl:choose>
<xsl:when test="local-name()='mo' and text()!=')' and text()!='(' and text()!=']' and text()!='[' and text()!='}' and text()!='{' and (count(preceding-sibling::*) = 0 or count(following-sibling::*) = 0)">mn</xsl:when>
<xsl:otherwise><xsl:value-of select="local-name()"/></xsl:otherwise>
</xsl:choose>
</xsl:variable>
<xsl:apply-templates mode="noImb" select="text() | *">
<xsl:with-param name="pNodeName" select="$vNodeName"/>
</xsl:apply-templates>
</xsl:template>
	
<xsl:template match="text()" mode="noImb" priority="2">
<xsl:param name="pNodeName"/>
<xsl:if test="string-length(normalize-space(.))&gt;0">
<xsl:choose>
<xsl:when test="$pNodeName='mo' and string-length(.)>1">
<xsl:element name="math:mi">
<xsl:call-template name="tInspectContent"><xsl:with-param name="pContent"><xsl:value-of select="."/></xsl:with-param></xsl:call-template>
</xsl:element>
</xsl:when>
<xsl:otherwise>
<xsl:element name="math:{$pNodeName}">
<xsl:call-template name="tInspectContent"><xsl:with-param name="pContent"><xsl:value-of select="."/></xsl:with-param></xsl:call-template>
</xsl:element>
</xsl:otherwise>
</xsl:choose>
</xsl:if>
</xsl:template>
<xsl:template match="*" mode="noImb">
<xsl:apply-templates select="current()"/>
</xsl:template>
	
	
<xsl:template match="math:msub//math:msub | math:msup//math:msup | math:msub//math:msup | math:msup//math:msub">
<xsl:apply-templates/>
</xsl:template>
	
	
<xsl:template match="math:mo[text()='{' and not(following-sibling::math:mo[text()='}'])]">
<math:mi>{</math:mi>
</xsl:template>
	
	
<xsl:template match="math:mover/@accent"/>
	
	
<xsl:template match="math:mover[local-name(*[2])='mspace']">
<xsl:apply-templates select="*[local-name()!='mspace']"/>
</xsl:template>
	
	
<xsl:template name="tInspectContent">
<xsl:param name="pContent"/>
		
<xsl:value-of select="translate($pContent, '&#x02146;&#x02148;&#x02062;&#x02061;&#x02063;', '&#160;&#160;&#160;&#160;&#160;')"/>
</xsl:template>
	
<xsl:template match="@*|node()">
<xsl:copy>
<xsl:apply-templates select="@*|node()"/>
</xsl:copy>
</xsl:template>
	
</xsl:stylesheet>